import * as types from '../const'

import { setStars } from './stars'

const createAction = <Payload>(type: string) => (payload?: Payload) => ({ type, payload })

const fetchUsers = createAction(types.USER_FETCH)
const success = createAction(types.USER_FETCH_SUCCESS)
const error = createAction<string>(types.USER_FETCH_ERROR)
export const reset = createAction(types.USER_FETCH_RESET)

export const getUsers = () => async (dispatch, getState) => {
  dispatch(fetchUsers())

  try {
    const response = await fetch('/api/users/')

    if (response.ok) {
      const data = (await response.json()).body
      dispatch(success(data))

      Object.keys(data).forEach(userId => {
        dispatch(setStars({ id: userId, value: data[userId].rated }))
      })
    } else {
      throw 'Что-то пошло не так'
    }

  } catch (e) {
    dispatch(error('Что-то пошло не так'))
  }
}