import { createSelector } from '@reduxjs/toolkit'

import { StoreType } from '../store'
import { Statuses } from '../reducers/users'

import { rootSelector } from './rootSelector'

const usersRootSelector = createSelector(rootSelector, (state: StoreType) => state.user)

export const isLoading = createSelector(usersRootSelector, (state) => state.status === Statuses.FETCHING)
export const data = createSelector(usersRootSelector, (state) => state.data)
export const error = createSelector(usersRootSelector, (state) => state.error)
