import { configureStore } from '@reduxjs/toolkit'
import { useSelector } from 'react-redux'

import { starsReducer } from './reducers/stars'
import { reducer as usersFetchReducer } from './reducers/users'

export const store = configureStore({
  reducer: {
    stars: starsReducer,
    user: usersFetchReducer,
  },
  devTools: {
    name: 'stars',
  },
  middleware: (getDefaultMiddleware) => getDefaultMiddleware(),
})

export type StoreType = ReturnType<typeof store.getState>

export const useAppSelector = useSelector<StoreType>
