import { HStack } from '@chakra-ui/react'
import React, { memo, useEffect, useState } from 'react'
import { useDispatch } from 'react-redux'

import { Profile } from '../components'
import { users } from '../__data__/users'
import { setStars } from '../__data__/actions/stars'
import { ProfileEditModal } from '../components/profileEdit'
import { getUsers } from '../__data__/actions/users'
import { UnknownAction } from 'redux'
import { useAppSelector } from '../__data__/store'
import { Statuses } from '../__data__/reducers/users'
import { userSelectors } from '../__data__/selectors'

export const Friends = memo(() => {
  // const [isLoading, setIsLoading] = useState(false)
  // const [data, setData] = useState(null)
  // const [error, setError] = useState(null)
  const dispatch = useDispatch()
  const [showModal, setShowModal] = useState(false)

  const isLoading = useAppSelector(userSelectors.isLoading)
  const data = useAppSelector(userSelectors.data)
  const error = useAppSelector(userSelectors.error)

  useEffect(() => {
    dispatch(getUsers() as unknown as UnknownAction)
  }, [])

  if(!data || isLoading) return <h1>loading...</h1>
  
  return (
    <>
      {showModal && <ProfileEditModal onClose={() => setShowModal(false)} />}
      <HStack>
        <Profile onOpenModal={() => setShowModal(true)} user={data['some-user-id']} />
        <Profile onOpenModal={() => setShowModal(true)} user={data['2']} />
      </HStack>
    </>
  )
})

Friends.displayName = 'memo(Friends)'
